<?php
/**
 * PHP editor és szintaxis (részped szemantika) ellenör
 * @author  Fogler Tibor
 * @authoremail tibor.fogler@gmail.com
 * @licence GNU/GPL
 * @copyright none
 */      

require 'PHP-Parser-0.9.3/lib/bootstrap.php'; 
require 'includes/phpchecker.php'; 
include 'includes/config.php'; 
session_start();

if (isset($_GET['f']))
  $fileName = $_GET['f'];
else
  $fileName = '';  
if (strpos($fileName,'model')>0)
  $title = 'Model';
else if (strpos($fileName,'view')>0)
  $title = 'View';
else if (strpos($fileName,'controller')>0)
  $title = 'Controller';
else if (strpos($fileName,'helper')>0)
  $title = 'Helper';
else
  $title = basename($fileName);
if ($title == '') $title = "PHPeditor";      
echo '
<html>
<head>
  <meta http-equiv="content-type" content="text/html; charset=utf-8" />
 	<script language="Javascript" type="text/javascript" src="editarea_0_8_2/edit_area/edit_area_full.js"></script>
  <style type="text/css">
    body {font-family:arial; font-size:12px;}
  </style>
  <title>'.$title.'</title>
</head>
<body>
<table border="0" width="100%">
  <tbody>
    <tr>
      <td><a href="http://adatmagus.hu"><img src="logo_190x90.jpg" height="50" /></a></td>
      <td align="center"><h1>&nbsp;&nbsp;PHP editor + checker</h1></td>
      <td><a href="olvassel.html" target="_blank">Olvass el</a><br />V1.00</td>
    </tr>
  </tbody>
</table>
'; 

if (!isset($_SESSION['adatmagus_phpeditor_user'])) {
   if (isset($_POST['user'])) {
     // check login
     if (($_POST['user'] != $user) |
         ($_POST['psw'] != $psw) |
         ($_POST['adatmagus_secret'] != $_SESSION['adatmagus_secret'])){
         echo '<p>Access denied</p>
         </body>
         </html>';
         exit();
      }
      $_SESSION['adatmagus_phpeditor_user'] = $_POST['user'];
   } else {
     // echo login form
     $secret = md5(time() + 112);
     $_SESSION['adatmagus_secret'] = $secret;
     echo '
     <center>
     <form method="post" action="#">
     <br />&nbsp;&nbsp;User Name:
     <input type="text" name="user" />
     &nbsp;Password:
     <input type="password" name="psw" />
     <input type="hidden" name="adatmagus_secret" value="'.$secret.'" />
     &nbsp;<button type="submit">Login</button><br />
     </form>
     </center>
     </body>
     </html>
     ';
     exit();
   }
} // user loged in?
$_SESSION['adatmagus_phpeditor_user'] = $_SESSION['adatmagus_phpeditor_user'];
if (isset($_GET['logout'])) {
  unset($_SESSION['adatmagus_phpeditor_user']);
  echo '<p>Good by</p>
  </body>
  </html>';
  exit();
}
if (isset($_GET['d']))
  $dirName = urldecode($_GET['d']);
else
  $dirName = $rootDir;
if (isset($_GET['f']))
  $fileName = urldecode($_GET['f']);
else
  $fileName = '';
if (isset($_POST['code']))
  $code = urldecode($_POST['code']);
else
  $code = '';
if (substr($dirName,0,strlen($rootDir)) != $rootDir)
   $dirName = $rootDir; 

if ($code != '') {
    // check and save $code
    $viewName = '';
    $comDir = '';
    $nmsFileName = '';
    $code = str_replace('{textarea','<textarea',$code);
    $code = str_replace('{/textarea}','</textarea>',$code);
    // valami rejtées okból a textarea a "+" karaktereket szoközzel helyettesíti.
    // ezért a submit előtt ezelket átkodoltam {add} -ra.
    $code = str_replace('{add}','+',$code);
    $parser     = new PHPParser_Parser(new PHPParser_Lexer);
    $phpChecker = new phpCheckerClass();
   
    // névtér bövítás Joomla szabványos .nmsp fájlokkal
    $nmsFileName = str_replace('.php','.nms',$fileName); 
    if (strpos($fileName,'models')>0) {
      $viewName = str_replace('.php','',basename($fileName));
      $comDir = dirnamedirname(($fileName));
    } else if (strpos($fileName,'controllers')>0) {
      $viewName = str_replace('.php','',basename($fileName));
      $comDir = dirname(dirname($fileName));
    } else if (strpos($fileName,'view.html')>0) {
      $viewName = basename(dirname($fieName));
      $comDir = dirname(dirname(dirname($fileName)));
    } else {
      $viewName = '';
      $comDir = '';
    }
    if ($viewName != '') {
      $phpChecker->loadNameSpace($comDir.'/helper.nms');
      $phpChecker->loadNameSpace($comDir.'/models/'.basename($nmsFileName));
      $phpChecker->loadNameSpace($comDir.'/controllers/'.basename($nmsFileName));
      $phpChecker->loadNameSpace($comDir.'/views/'.$wiewName.'/'.basename($nmsFileName));
    }    
    try {
      $stmts = $parser->parse($code);
      if ($phpChecker->stmtsChecker($stmts,$fileName))
        echo '<hr /><h2>Saved not error</h2><hr />';
      else
        echo '<hr /><h2>Saved</h2>'.$phpChecker->errorMsg.'<hr />';
    } catch (PHPParser_Error $e) {
      echo '<h2>Saved</h2>Parse Error: ', $e->getMessage().'<br />';
    }
  
    // make old version
    for ($i=$oldVersionLevel; $i>0; $i=$i-1) {
      if (file_exists($fileName.'.old'.($i-1)))
        rename($fileName.'.old'.($i-1),$fileName.'.old'.$i);
    }
    if (file_exists($fileName))
      rename($fileName,$fileName.'.old1');
      
    // save code
    $fp = fopen($fileName,'w+');
    fwrite($fp,$code);
    fclose($fp);
    
    // save .nms file
    /*
    if (count($phpChecker->classNames) > 0)
      $phpChecker->saveNameSpace(dirname($fileName).'/'.$w1);
    */
    // rá csorog a következő if -re 
} 
if ($fileName != '') {
    // echo editor form
     echo '
  	<script language="Javascript" type="text/javascript">
  		// initialisation
      editAreaLoader.init({
  			id: "code1"	// id of the textarea to transform		
  			,start_highlight: true	// if start with highlight
  			,allow_resize: "both"
        ,min_width: 600
        ,min_height: 200
  			,allow_toggle: true
  			,word_wrap: true
  			,language: "en"
  			,syntax: "php"	
  		});
      function save() {
        document.forms.adminForm.code.value = editAreaLoader.getValue("code1");
        editAreaLoader.delete_instance("code1");
        document.forms.adminForm.code.value =
          document.forms.adminForm.code.value.replace(/\+/g,"{add}");
        document.forms.adminForm.submit();
      }
      
    </script>  
    ';  
     
     echo '<h2>'.$fileName.'</h2><hr />';
     $lines = file($fileName);
     $code = implode('',$lines);
     $code = str_replace('<textarea','{textarea',$code);
     $code = str_replace('</textarea>','{/textarea}',$code);
     echo '
     <table border="0" width="100%">
     <tbody>
     <tr>
     <td>&nbsp;</td>
     <td align="center">
     <form name="form2">
     <textarea name="code1" id="code1" cols="100" rows=23">'.$code.'</textarea>
     </form>
     <form method="post" name="adminForm" action="?f='.urlencode($fileName).'">
     <input type="hidden" name="code" />
     <button type="button" onclick="save()">Check + Save</button>
     </form>
     </td>
     <td>&nbsp;</td>
     </tr>
     </tbody>
     </table>
     ';
} else {
  // echo dirList
  echo '
   <table border="0" width="100%">
   <tbody>
   <tr>
   <td>&nbsp;</td>
   <td align="center">
   <h2>'.$dirName.'</h2><hr />
   <div style="text-align:left; width:400px;">';
  if (is_dir($dirName)) {
    if ($dh = opendir($dirName)) {
        while (($file = readdir($dh)) !== false) {
           if ($file == '.') {
             ;
           } else if ($file=='..') {
             echo '<a href="?d='.urlencode(dirname($dirName).'/').'">..</a><br />
             ';
           } else if (is_dir($dirName.$file)) {  
             echo '<a href="?d='.urlencode($dirName.$file.'/').'">'.$file.'</a><br />
             ';
           } else if (strpos($file,'.php')>0) {
             echo '<a href="?f='.urlencode($dirName.$file).'" target="_blank">'.$file.'</a><br />
             ';
           } else {
             echo $file.'<br />
             ';
           }
        }
        closedir($dh);
    }
    echo '
    </div>
    </td>
    <td>&nbsp;</td>
    </tr>
    </tbody>
    </table>
    ';
  } else {
    echo '<p>not a directory</p>';
  }
}
echo '
<p style="text-align:right">
  <a href="index.php?logout=y">Logout</a>&nbsp;&nbsp;&nbsp;
</p>
</body>
</html>
';
?>